<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema">

<!--
<xsl:param name="bgcolor1">#FFFFCC</xsl:param>
<xsl:param name="bgcolor2">#BCD2EE</xsl:param>
<xsl:param name="bgcolor3">#FFA54F</xsl:param>
<xsl:param name="bgcolorPerson">#33FFCC</xsl:param>
<xsl:param name="bgcolorGeo">#FF00CC</xsl:param>
-->

<xsl:variable name="lower">abcdefghijklmnopqrstuvwxyz</xsl:variable>
<xsl:variable name="upper">ABCDEFGHIJKLMNOPQRSTUVWXYZ</xsl:variable> 

<!--  http://groups.google.com/group/xml-and-xslt/browse_thread/thread/7d9107c158839560?pli=1 -->
<!--
   <xsl:value-of select="translate('foo',$lower,$upper)"/>
   <xsl:value-of select="translate('BAR',$upper,$lower)"/>
-->


<xsl:variable name="PersonUnique" select=	 	"count(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/Person)"/>
<xsl:variable name="PersonCount" select="sum(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/Person/@count)"/>

<xsl:variable name="PositionUnique" select="count(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/Position)"/>
<xsl:variable name="PositionCount" select="sum(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/Position/@count)"/>

<xsl:variable name="CityUnique" select="count(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/City)"/>
<xsl:variable name="CityCount" select="sum(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/City/@count)"/>
 
<xsl:variable name="ProvinceOrStateUnique" select="count(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/ProvinceOrState)"/>
<xsl:variable name="ProvinceOrStateCount" select="sum(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/ProvinceOrState/@count)"/>

<xsl:variable name="CountryUnique" select="count(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/Country)"/>
<xsl:variable name="CountryCount" select="sum(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/Country/@count)"/>

<xsl:variable name="ContinentUnique" select="count(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/Continent)"/>
<xsl:variable name="ContinentCount" select="sum(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/Continent/@count)"/>

<xsl:variable name="LocationUnique" select="$CityUnique + $ProvinceOrStateUnique + $CountryUnique + $ContinentUnique"/>
<xsl:variable name="LocationCount" select="$CityCount + $ProvinceOrStateCount + $CountryCount + $ContinentCount"/>

<xsl:variable name="AllUnique" select="count(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/*[@count>0])"/>
<xsl:variable name="AllCount" select="sum(document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/*/@count)"/>

<xsl:variable name="MiscUnique" select="($AllUnique - ($PersonUnique + $PositionUnique))"/>
<xsl:variable name="MiscCount" select="($AllCount - ($PersonCount + $PositionCount))"/>


<!-- The main template for the root. -->
<xsl:template match="/">

  <!-- HTML code -->
  <html>
    <head>
		<!--<link href="style.css" type="text/css" rel="stylesheet"/>-->
		<!--<link href="XERjudge.css" type="text/css" rel="stylesheet"/>-->
		<link href="style.css" type="text/css" rel="stylesheet"/>
		
		<title>
			<!-- Title of the page -->
			Calais NER for "<xsl:value-of select="/index/title"/>" by <xsl:value-of select="/index/author"/> (<xsl:value-of select="count(/index/filelist/file)"/> chapters)
		</title>
	</head>
	
	<body>
	<!-- The document title -->
	
	<div id="wrap">	
	
	<h1 id="header">
		<!-- Select the value for the doc title-->
		Calais NER for "<xsl:value-of select="/index/title"/>" by <xsl:value-of select="/index/author"/> 
		(<xsl:value-of select="count(/index/filelist/file)"/> chapters)
	</h1>

<!--	
	<p><em>Download the INEX <a href="../topics-2006-005.tar.gz">topics-2006-005</a> in XML format.</em></p>
	<p><em>Download all the INEX topics-2006-005 in one single file. The file names are self-descriptive.</em></p>
	<ol>
		<li><a href="topics-2006-005_topic_id_title.txt">topics-2006-005_topic_id_title.txt</a></li>
		<li><a href="topics-2006-005_topic_id_title_ontopic_keywords.txt">topics-2006-005_topic_id_title_ontopic_keywords.txt</a></li>
		<li><a href="topics-2006-005_topic_id_title_description_ontopic_keywords.txt">topics-2006-005_topic_id_title_description_ontopic_keywords.txt</a></li>
		<li><a href="topics-2006-005_topic_id_title_description_narrative_ontopic_keywords.txt">topics-2006-005_topic_id_title_description_narrative_ontopic_keywords.txt</a></li>
	</ol>
-->	

		<xsl:apply-templates select="/" mode="indexFilesMenu"/>
		<p>
			<strong>LEGEND: </strong>(unique by Calais - i.e. we may have the same entity occuring in different chapters)
			<div id="Person">Person 
				[unique: <xsl:value-of select="$PersonUnique"/>, 
				count: <xsl:value-of select="$PersonCount"/>]		
			</div>
			<div id="Position">Position
				[unique: <xsl:value-of select="$PositionUnique"/>, 
				count: <xsl:value-of select="$PositionCount"/>]		
			</div>
			
			<div id="Location">Location 
				[unique: <xsl:value-of select="$LocationUnique"/>, 
				count: <xsl:value-of select="$LocationCount"/>]	
				:
			City
				[unique: <xsl:value-of select="$CityUnique"/>, 
				count: <xsl:value-of select="$CityCount"/>]	
				, 
			ProvinceOrState
				[unique: <xsl:value-of select="$ProvinceOrStateUnique"/>, 
				count: <xsl:value-of select="$ProvinceOrStateCount"/>]	
				, 
			Country
				[unique: <xsl:value-of select="$CountryUnique"/>, 
				count: <xsl:value-of select="$CountryCount"/>]	
				, 
			Continent	
				[unique: <xsl:value-of select="$ContinentUnique"/>, 
				count: <xsl:value-of select="$ContinentCount"/>]	

			</div>

			<div id="Misc">Misc 
							[unique: <xsl:value-of select="$MiscUnique"/>, 	
							count: <xsl:value-of select="$MiscCount"/>]		
			</div>

			<div id="Misc">All 
							[unique: <xsl:value-of select="$AllUnique"/>, 	
							count: <xsl:value-of select="$AllCount"/>]		
			</div>
<!--
			<xsl:apply-templates select="document(/index/filelist/file/@id)/OpenCalaisSimple/CalaisSimpleOutputFormat" mode="Count">
				<xsl:with-param name="type">Person</xsl:with-param>
			</xsl:apply-templates>	
-->		
		</p>

		<!--
		<xsl:apply-templates select="/" mode="CountUniquePersons">
			<xsl:with-param name="unique">0</xsl:with-param>
		</xsl:apply-templates>	
		-->
		<xsl:apply-templates select="/" mode="processFiles"/>
	</div>	
	</body>
  </html>
</xsl:template>


<xsl:template match="*" mode="indexFilesMenu">
	<ol><strong>
	<!--<li><a href="74-index-calais.xml">ff<xsl:value-of	select="document(74-index-calais.xml)/index/title"/>ff</a></li>-->
	<li><a href="index-calais.xml">Tom Sawyer Adventure Series</a></li>
	<li><a href="74-index-calais.xml">The Adventures of Tom Sawyer</a></li>
	<li><a href="76-index-calais.xml">The Adventures of Huckleberry Finn</a></li>
	<li><a href="91-index-calais.xml">Tom Sawyer Abroad</a></li>
	<li><a href="93-index-calais.xml">Tom Sawyer Detective</a></li>
	</strong>
	</ol>


	<p><em>Download the Tom Sawyer Adventure Series in TXT format (fragments ~= chapters) 
	<strong>
		<a href="http://homepages.cwi.nl/~media/blue_book/sw4xmlir/TomSawyer/TomSawyerTXT.zip">TomSawyerTXT.zip</a>
	</strong>.</em></p>

	<p>
	<em>Download the Tom Sawyer Adventure Series (fragments ~= chapters) annotated using the Calais Web service (input RAW TEXT, output: CalaisSimple OutputFormat) and linked with DBpedia and Geonames data 
	<strong>
	<a href="http://homepages.cwi.nl/~media/blue_book/sw4xmlir/TomSawyer/TomSawyerTXT[RAW-Simple].zip">TomSawyerTXT[RAW-Simple]</a>
	</strong> 
	or 	
	<strong>
		<a href="http://homepages.cwi.nl/~media/blue_book/sw4xmlir/TomSawyer/TomSawyerTXT%5BRAW-Simple%5D/">Browse</a>
	</strong> the files.</em>
	</p>

	<p><em>Download the detailed log file <strong><a href="log.txt">log.txt</a></strong> for the Tom Sawyer Adventure Series.</em></p>
		<code>
		Stats for DBpedia retrieval:<br/>

* number of DBpedia queries is: 646<br/>

+ number of person queries: 646<br/>

- number of persons found: 118<br/>

- number of persons not found: 524<br/>

Stats for GeoNames retrieval:<br/>

* number of Geonames queries is: 138<br/>

+ number of city queries: 73<br/>

- number of cities found: 69<br/>

- number of cities not found: 4<br/>

- number of cities with broader relationship found: 0<br/>

- number of cities with broader relationship not found: 0<br/>

+ number of country queries: 53<br/>

- number of countries found: 53<br/>

- number of countries not found: 0<br/>

+ number of continent queries: 12<br/>

- number of continents found: 12<br/>

- number of continents not found: 0<br/>

- Finished processing, arguments used: <br/>

+ -c, --calais<br/>

+ -d, --dbpedia<br/>

+ -g, --geonames<br/>

+ -i, --idrank<br/>
		</code>

</xsl:template>


<xsl:template match="*" mode="Count">
	<xsl:param name="type"/>

	<xsl:variable name="nodes" select="$type"/>
	
	<div id="{$type}">
		<xsl:value-of select="$type"/>
		[unique: <xsl:value-of select="count(Person)"/>, 
		 count: <xsl:value-of select="sum(Person/@count)"/>]		
	</div>
</xsl:template>


<xsl:template match="Person" mode="CountUniquePers">
	<p id="Person"><xsl:value-of select="count(.)"/> persons</p>
	<p id="Person"><xsl:value-of select="sum(@count)"/> persons</p>
</xsl:template>

<xsl:template match="*" mode="CountUniquePersons">
	

	
	<xsl:for-each select="/index/filelist/file">
		<p id="Person">
		<strong><xsl:value-of select="@id"/></strong>
		
		
		[unique: <xsl:value-of select="count(document(@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/Person/@count)"/>, 
		count: <xsl:value-of select="sum(document(@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/Person/@count)"/>] <br/>
		<i>
		<xsl:for-each select="document(@id)/OpenCalaisSimple/CalaisSimpleOutputFormat/Person">
			<xsl:value-of select="."/> 
			(<xsl:value-of select="@count"/>)
		</xsl:for-each>
		</i>
		</p>		
	</xsl:for-each>
</xsl:template>


<!-- Template to print simple content-->
<xsl:template match="/" mode="content">
			<xsl:for-each select=".//*">
				<xsl:value-of select="text()"/>
			</xsl:for-each>
</xsl:template>

<!-- Template to print content and structure-->
<xsl:template match="*|@*" mode="contentandstructure">
			<xsl:for-each select=".//*">
				<strong><xsl:value-of select="name()"/> : </strong>
					<xsl:for-each select="./@*">
						<xsl:value-of select="name()"/>="<xsl:value-of select="."/>"  
					</xsl:for-each>
				<xsl:value-of select="text()"/><br/>
			</xsl:for-each>
</xsl:template>

	
<!-- Template to process CalaisSimpleOutputFormat-->
<xsl:template match="*" mode="CalaisSimpleOutputFormat">
	<xsl:param name="bgcolor"/>

	<div id="{$bgcolor}">
			<xsl:for-each select=".//*">
			    <xsl:sort select="name()"  data-type="text" order="ascending" case-order="upper-first"/>
				<xsl:choose>
					<xsl:when test="name() = 'Person'">
						<div id="Person">
							<!-- open a rdf file like this 'DBpedia-person-brace_dunlap.rdf '-->
							<xsl:value-of select="name()"/>: 
							
							<a href="{concat('DBpedia-person-', translate(translate(.,$upper,$lower),' ','_'),'.rdf')}">
								<strong><xsl:value-of select="concat (., ' ')"/></strong> 
							</a>

							<xsl:apply-templates select="." mode="printAtt"/>
						</div>
					</xsl:when>
					
					<xsl:when test="name() = 'Position'">
						<div id="Position">
							<xsl:value-of select="name()"/>: 
								<strong><xsl:value-of select="."/></strong> 
							<xsl:apply-templates select="." mode="printAtt"/>
						</div>
					</xsl:when>
					
					<xsl:when test="(name() = 'City') or (name() = 'Continent') or (name() = 'Country') or (name() = 'ProvinceOrState')">
						<div id="Location">
							<xsl:value-of select="name()"/>: 
							<!-- used to link to files like this 'Geonames-city-st._louis.rdf' , 'Geonames-continent-america.rdf'-->
							<xsl:variable name="geolink">
								<xsl:value-of select="concat(
									'Geonames-', 
									translate(name(),$upper,$lower), '-', 
									translate(translate(.,$upper,$lower),' ','_'),
									'.rdf')" />
							</xsl:variable>
							
							<a href="{$geolink}">
								<strong><xsl:value-of select="."/></strong> 
							</a>
							
							<xsl:apply-templates select="." mode="printAtt"/>
						</div>
					</xsl:when>


					<xsl:otherwise>
						<div id="Misc">
							<xsl:value-of select="name()"/>: <strong><xsl:value-of select="."/></strong>
							<xsl:apply-templates select="." mode="printAtt"/>	
						</div>
					</xsl:otherwise>
				</xsl:choose>	
			</xsl:for-each>
	</div>
</xsl:template>

<!-- Template to print att & attValues-->
<xsl:template match="*" mode="printAtt">
			 (<xsl:for-each select="./@*">
								<i>
								<xsl:value-of select="name()"/>="<xsl:value-of select="."/>"
								</i>
			</xsl:for-each>)
</xsl:template>


<!-- Template to create a summary with links, with line breaks-->
<xsl:template match="/" mode="processFiles">
	<xsl:for-each select="/index/filelist/file">
			<!--<a href="{concat('#', ./text(), '.xml')}"><xsl:value-of select="."/></a>-->
				<xsl:choose>
				
					<xsl:when test="(position( ) mod 2) = 0">
						
						
							<!--  <a href="{concat(./text(), '.xml')}"><xsl:value-of select="."/></a><br/> 	-->
							<a href="{concat(@id, '')}"><xsl:value-of select="@id"/></a><br/>
							<!-- 
							<p><xsl:apply-templates select="document(@id)" mode="contentandstructure"/></p> 
							<p><xsl:apply-templates select="document(@id)/OpenCalaisSimple/CalaisSimpleOutputFormat" mode="contentandstructure"/></p>
							-->
							
							<xsl:apply-templates select="document(@id)/OpenCalaisSimple/CalaisSimpleOutputFormat" mode="CalaisSimpleOutputFormat">
								<xsl:with-param name="bgcolor">BgColor1</xsl:with-param>
							</xsl:apply-templates>
							
							<!--<p><xsl:apply-templates select="document(@id)/OpenCalaisSimple/CalaisSimpleOutputFormat//*" mode="contentandstructure"/></p>-->
						
					</xsl:when>
					<xsl:otherwise>
							<a href="{concat(@id, '')}"><xsl:value-of select="@id"/></a><br/>
							<xsl:apply-templates select="document(@id)/OpenCalaisSimple/CalaisSimpleOutputFormat" mode="CalaisSimpleOutputFormat">
								<xsl:with-param name="bgcolor">BgColor2</xsl:with-param>
							</xsl:apply-templates>
					
					<!--
						<td bgcolor="{$bgcolor2}">
							<a href="{concat(@id, '')}"><xsl:value-of select="@id"/></a><br/>
							<hr/>
							<p><xsl:apply-templates select="document(@id)/OpenCalaisSimple/CalaisSimpleOutputFormat" mode="CalaisSimpleOutputFormat"/></p>
							<hr/>
						</td>
					-->	
					</xsl:otherwise>
				</xsl:choose>	
				<!--
				<xsl:value-of select="document(concat(./text(), '.xml'))/inex_topic/title/text()"/><br/>
				<xsl:value-of select="document(concat(./text(), '.xml'))/inex_topic/description/text()"/><br/>
				-->
				<p/>
	</xsl:for-each>
</xsl:template>
	

</xsl:stylesheet>